///////    Downloader.java    ///////
import java.io.*;
import java.net.*;
import java.util.StringTokenizer;
import In;

public class Downloader
{  
   	protected File fileobj = null;
   	protected URLConnection ser = null;
   	protected OutputStream out = null;
   	protected boolean fileCreated = false;
   	protected boolean done = false;

	public Downloader(String url)   //  Un constructor
   	{ try
     {  URL urlobj = new URL(url); //  Definimos un objeto URL
        String file = simpleFilename(urlobj.getFile());
		//  Retorna el nombre del archivo asociado al url.
	
		System.out.println("( 3) - Aqui Downloader, me piden: "+file);
        ser = urlobj.openConnection();
		//  ser representa la coneccion al objeto URL remoto 

        if ( file == null )
        {   file = ser.getContentType();
			//  Tipo del contenido del recurso que el URL referencia 

           file = "download." + file.replace('/','-');
        }  //  nuevo nombre: "download." + contenido de file, 
		   // previo reemplazo de "/" por "-"

        fileobj = new File(file);
		// Creamos un nuevo objeto File

		out = new FileOutputStream(fileobj);
		// Creamos un flujo de salida para File fileobj 

        fileCreated = true;
        System.out.println("( 4) - La descarga ser en "+file);
     }  catch (MalformedURLException e) {System.out.println("Line 33,Exception, MalformedURL");}
        catch (IOException e) {System.out.println("Line 34,Exception IO");}
   }

   protected Downloader() {}

   public boolean isReady()
   { return (ser != null && out != null); }

   public boolean isDone()
   { return done; }

   public String filename() { return fileobj.getName(); }

   String simpleFilename(String s)
   {   String a = null;
       StringTokenizer t = new StringTokenizer(s,"/");
       while ( t.hasMoreTokens() )
             a = t.nextToken();
       return a;
   }

   public void download(String msg) //  Preparativos previos a descarga
   {  try
      {  System.out.println("( 7) - ser.setDoOutput(true);");
	  	 ser.setDoOutput(true); 
	  	 // doOutput verdadero, entonces coneccion de salida 
		 System.out.println("( 8) - new PrintWriter(... ");
         PrintWriter out = new PrintWriter(ser.getOutputStream());
		 //  out es el stream que grabar en la URLConnection ser 
         System.out.println("( 9) - out.println(msg);");
         out.println(msg); 
		 //  grabamos en la URLConnection ser
         System.out.println("(10) - out.close();");
         out.close();
		 //  cerramos el flujo hacia la URLConnection
         System.out.println("(11) - download();");
         download();
		 //  descargamos
      }  catch (IOException e) {System.out.println("Line 68, Exception IO");}
   }

   public void download()   //  Descarga propiamente dicha
   { System.out.println("(12) - if ( ! isReady() )");
   	 if ( ! isReady() )
   	   {	System.out.println("Mala coneccion - !isReady()");
            // Mala coneccion, nada podemos hacer ...
            return;
   	   } 
     try
     {  System.out.println("(13) - ser.getInputStream();");
	 	InputStream in = ser.getInputStream();
	 	//  definimos in, un flujo de entrada desde la coneccion abierta.
        int c;
        System.out.println("(14) - while ( (c = in.read(... ");
        while ( (c = in.read()) > -1 )
		//  Mientras hayan bytes en ese flujo
              out.write(c);
			  //  los grabaremos ... 
        in.close();
        System.out.println("(15) - out.close();");
        out.close();
        done = true;
     }  catch (IOException e) {System.out.println("Line 76,Exception IO");}
   }

   public void finalize()
   {  if ( ! done && fileCreated )
          fileobj.delete();
   }

   public static void main(String[] args)
   { 
   String algunURL;
   System.out.print("( 1) - Pgina y archivo, por favor: ");
   algunURL = "http://"+In.readLine();

   System.out.println("( 2) - Downloader: descarga. "+algunURL+", por favor");
   Downloader d = new Downloader(algunURL);
   if ( ! d.isReady() ) //  Algo fallo en la construccin
    	{   System.out.println("Lamento, constructor Downloader ha fracasado!!!");
        	d.finalize();
	 		return;
     	}
   System.out.println("( 5) - Preparamos datos para grabar en la URLConection");
		
   StringBuffer msg = new StringBuffer();
   //  msg es como String, pero modificable

   msg.append(algunURL);
   //  Appendamos la hilera algunURL al StringBuffer msg

   msg.append(URLEncoder.encode(algunURL));
   //  La misma hilera, ahora en formato URLEncoder
   System.out.println("( 6) - download(String): grabamos en la URLConection");
   d.download(new String(msg));
   //  Ejecutamos la descarga
     if ( d.isDone() )
	   System.out.println("(16) - DESCARGADO !!! "
	    + d.filename());
     else 
       System.out.println("Descarga de archivo: " + d.filename() 
	    + " - CON PROBLEMAS !!!");
   }
}


// example usage
// jv Downloader \
// '"http://SymbolicNet.mcs.kent.edu/cgi-bin/icm.demo?factor+y^2-x^2"'\
//  'polynomial='    '"x^4-y^4"'


