//  Gateway para el primer practico de Trabajo en Red

//  Author: Tymoschuk, Jorge

import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

public class Prac001{  //
   	private File       file; 
   	private RandomAccessFile iofile;
   	private String legLei, curLei,  aNomLei;
   	private String algoDecir="";
   	private String direct, archivo, curso, legajo, apeNoms;
	public Prac001(String[] args){
   		direct   = args[0];	// Directorio (tymos)
   		archivo  = args[1];	// Archivo    (regPra01)
   		curso    = args[2];	// Donde cursas ?
   		legajo   = args[3];	// Legajo UTN
   		apeNoms  = args[4];	// Apellido, Nombres 
	}

   	public static void main (String[] args) throws IOException{
   	 	Prac001 gtw = new Prac001(args);
		if (gtw.errorParm(args))return;

		// Consistencia de argumentos: correcta
	   	if (gtw.openRAF())		// Consigo abrir Random Access File
	   		if(!gtw.existeLeg()) // No tengo legajo: alta 
	   			gtw.grabRAF();
	}

	boolean errorParm(String[] args) throws IOException{
	   if ( args.length != 5){	// Cantidad de parametros difiere   	
			System.out.println("Content-Type: text/html");  // 1st line
	   		System.out.println();                           // empty line
	   		System.out.println("<html><H1> Error in parameters </H1>");
	   		System.out.println("<P>Quantity received differs from expected<P></html>");
			return true;
		}
		if ( !args[0].equals("tymos")){ 	// Directorio mal informado   	
			System.out.println("Content-Type: text/html");  // 1st line
	   		System.out.println();                           // empty line
	   		System.out.println("<html><H1> Error in parameters </H1>");
	   		System.out.println("<P>args[0] differs from tymos <P></html>");
			return true;
		}
		if ( !args[1].equals("regPra01")){ // Archivo mal informado   	
			System.out.println("Content-Type: text/html");  // 1st line
			System.out.println();                           // empty line
			System.out.println("<html><H1> Error in parameters </H1>");
			System.out.println("<P>args[1] differs from regPra01 <P></html>");
			return true;
		}
		return false;
	}

	boolean openRAF(){
		file = new File("./"+direct+"/"+archivo);
		try	{iofile = new RandomAccessFile(file,"rw");
			return true;
		}catch (IOException e){
			System.out.println("Content-Type: text/html");  // 1st line
			System.out.println();                           // empty line
			System.out.println("<html><H1> Error in new RAF </H1>");
			System.out.println("<P>openRAF(), IOException<P></html>");
			return false;
			}	
	}	//	openRAF()
	
	boolean existeLeg(){
		if(file.length()==0) return false; // primera vez
		String legLei="00.000"; 
		try{
			while(true){
				if(legLei.equals(legajo)){	// Encontre igual
					System.out.println("Content-Type: text/html");  // 1st line
					System.out.println();                           // empty line
					System.out.println("<html><H1> Existes !!</H1>");
					System.out.println("<P>"+apeNoms+"<P></html>");
				 	return true;
				} 
				// 
				legLei= iofile.readUTF();	//  legajo
			  	curLei= iofile.readUTF();	//  curso
			  	aNomLei=iofile.readUTF();	//	nombres
			  			iofile.readUTF();	//	algo que quiero decir
			}
		}  	catch(EOFException e){return false;} // No tengo legajo
			catch(IOException e){
				System.out.println("Content-Type: text/html");  // 1st line
				System.out.println();                           // empty line
				System.out.println("<html><H1> Error de lectura (?) </H1>");
				System.out.println("<P>existeLeg(), IOException<P></html>");
				System.exit(1);
			}
		return true;		
	}	//	existeLeg()

	void grabRAF(){
		try{
			iofile.writeUTF(legajo);
		  	iofile.writeUTF(curso);
		  	iofile.writeUTF(apeNoms);
			// Ahora leemos el flujo enviado por el cliente.
		  	int c;
		  	while ((c = System.in.read() ) > -1 )
		  	      algoDecir+=c;
		  	iofile.writeUTF(algoDecir);
			iofile.close();
			// confirmacion del exito logrado 
			System.out.println("Content-Type: text/html");  // 1st line
			System.out.println();                           // empty line
			System.out.println("<html><H1> Practico exitoso !!! </H1>");
			System.out.println("<P>"+apeNoms+"<P></html>");
			System.exit(1);
		} catch (IOException e){
			System.out.println("Content-Type: text/html");  // 1st line
			System.out.println();                           // empty line
			System.out.println("<html><H1> Error de grabacion </H1>");
			System.out.println("<P>"+apeNoms+"<P></html>");
			System.exit(1);
			}
	}	//	grabRAF()

}

