//  Gateway para control del primer practico de Trabajo en Red
import java.io.*;
import java.net.*;
import java.util.StringTokenizer;
import java.lang.Integer;

public class Prac002{  //
   	private File       file; 
   	private RandomAccessFile iofile;
   	private String legLei, curLei,  aNomLei;
   	private String algoDecir="";
   	private String direct,archivo;
	private int desdeReg;
	public Prac002(String[] args){
   		direct   = args[0];	// Directorio (tymos)
   		archivo  = args[1];	// Archivo    (regPra01)
		desdeReg=Integer.parseInt(args[2]);	}

   	public static void main (String[] args) throws IOException{
   	 	Prac002 gtw = new Prac002(args);
		if (gtw.errorParm(args))return;

		// Consistencia de argumentos: correcta
	   	if (gtw.openRAF()) { 	// Consigo abrir Random Access File
			gtw.iniciahtml();
	   		if(gtw.avanzoReg()){ // consigo avanzar los indicados ...
	   			gtw.listo10();
				gtw.otrosMas();
			}
			gtw.finhtml();
		}
	}	

	boolean errorParm(String[] args) throws IOException{
	   if ( args.length != 3){	// Cantidad de parametros difiere   	
			System.out.println("Content-Type: text/html");  // 1st line
	   		System.out.println();                           // empty line
	   		System.out.println("<html><H1> Error in parameters </H1>");
	   		System.out.println("<P>Quantity received differs from expected</P></html>");
			return true;
		}
		if ( !args[0].equals("tymos")){ 	// Directorio mal informado   	
			System.out.println("Content-Type: text/html");  // 1st line
	   		System.out.println();                           // empty line
	   		System.out.println("<html><H1> Error in parameters[0] </H1>");
	   		System.out.println("<P>args[0] differs from tymos </P></html>");
			return true;
		}
		if ( !args[1].equals("regPra01")){ // Archivo mal informado   	
			System.out.println("Content-Type: text/html");  // 1st line
			System.out.println();                           // empty line
			System.out.println("<html><H1> Error in parameters [1]</H1>");
			System.out.println("<P>args[1] differs from regPra01 </P></html>");
			return true;
		}

		if ( desdeReg<0 ){ 			// cantidad mal informada   	
			System.out.println("Content-Type: text/html");  // 1st line
			System.out.println();                           // empty line
			System.out.println("<html><H1> Error in parameters[2] </H1>");
			System.out.println("<P>args[2] differs from expected</P></html>");
			return true;
		}
		return false;
	}

	boolean openRAF(){
		file = new File("./"+direct+"/"+archivo);
		try	{iofile = new RandomAccessFile(file,"rw");
			return true;
		}catch (IOException e){
			System.out.println("Content-Type: text/html");  // 1st line
			System.out.println();                           // empty line
			System.out.println("<html><H1> Error in new RAF </H1>");
			System.out.println("<P>openRAF(), IOException</P></html>");
			return false;
			}	
	}	//	openRAF()
	
	boolean avanzoReg(){
		if(file.length()==0) return false; // primera vez
		int leidos=0; 
		try{
			while(leidos < desdeReg){
				 iofile.readUTF();	//  legajo
				 iofile.readUTF();	//  curso
				 iofile.readUTF();	//	nombres
				 iofile.readUTF();	//	algo que quiero decir
				 leidos++;
			} 
		}  	catch(EOFException e){return false;} // No tengo suf.registros
			catch(IOException e){
				System.out.println("Content-Type: text/html");  // 1st line
				System.out.println();                           // empty line
				System.out.println("<html><H1> Error de lectura (?) </H1>");
				System.out.println("<P>existeLeg(), IOException</P></html>");
				System.exit(1);
			}
		return true;		
	}	//	avanzoReg()

	void listo10(){
		int cuento=0;
		try{
			while(cuento<10)
 {
				legLei= iofile.readUTF();
		  		curLei= iofile.readUTF();
		  		aNomLei=iofile.readUTF();
					iofile.readUTF();	// algo a decir ...
				algoDecir+=legLei+", "+curLei+", "+aNomLei+ "\n";
// Comentamos por debuging	System.out.println("<P> cuento="+cuento+" que tengo en algoDecir="+algoDecir+"</P>");
				cuento++;
			}

		}  	catch(EOFException e){;} // Fin de archivo, todo bien ...
  			catch (IOException e){
			System.out.println("Content-Type: text/html");  // 1st line
			System.out.println();                           // empty line
			System.out.println("<html><H1> Error de lectura</H1>");
			System.out.println("<P> listo10() </P></html>");
			System.exit(1);
			}
	}	//	listo10()
	
	void otrosMas(){
		System.out.println("<H1> Mas 10 Exitos !!</H1>");
		System.out.println("<P>"+algoDecir+"</P>");
		System.exit(1);
	}

	void iniciahtml(){
		System.out.println("Content-Type: text/html");  // 1st line
		System.out.println();                           // empty line
		System.out.println("<html>");
	}

	void finhtml(){
		System.out.println();                           // empty line
		System.out.println("</html>");
	}

}	// class Prac002



