import java.io.*;
import java.net.*;

/**
   Este programa implementa un servidor simple que escucha al puerto 8189
   y devuelve como un eco el texto del cliente. Finaliza cuando el cliente 
 * tipea Adios
*/
public class EchoServer
{  
   public static void main(String[] args )
   {  
      try
      {  
         // instanciamos un servidos ServerSocket que escucha al puerto 8189
         ServerSocket s = new ServerSocket(8189);

         Socket incoming = s.accept( );
         // Le indicamos que espere indefinidamente
         
         BufferedReader in = new BufferedReader
            (new InputStreamReader(incoming.getInputStream()));
         PrintWriter out = new PrintWriter
            (incoming.getOutputStream(), true /* autoFlush */);
         // instanciamos flujos de entrada y salida
         
         out.println( "Hola! Tipee Adios para salir..." );

         // echo client input
         boolean done = false;
         while (!done)
         {  
            String line = in.readLine();
            if (line == null) done = true;
            else
            {  
               out.println("Echo: " + line);

               if (line.trim().equals("Adios"))   
                  done = true;
            }
         }
         incoming.close();
      }
      catch (Exception e)
      {  
         e.printStackTrace();
      }
   }
}


