import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

/**
   Como enviar mensajes de correo usando sockets
*/
public class MailTest
{  
   public static void main(String[] args)
   {  
      JFrame frame = new MailTestFrame();
      frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      frame.show();
   }
}

/**
   La interfaz anterior ...
*/
class MailTestFrame extends JFrame
{  
   public MailTestFrame()
   {  
      setSize(WIDTH, HEIGHT);
      setTitle("MailTest");

      getContentPane().setLayout(new GridBagLayout());

      GridBagConstraints gbc = new GridBagConstraints();
      gbc.fill = GridBagConstraints.HORIZONTAL;
      gbc.weightx = 0;
      gbc.weighty = 0;

      gbc.weightx = 0;
      add(new JLabel("From:"), gbc, 0, 0, 1, 1);
      gbc.weightx = 100;
      from = new JTextField(20);
      add(from, gbc, 1, 0, 1, 1);

      gbc.weightx = 0;
      add(new JLabel("To:"), gbc, 0, 1, 1, 1);
      gbc.weightx = 100;
      to = new JTextField(20);
      add(to, gbc, 1, 1, 1, 1);

      gbc.weightx = 0;
      add(new JLabel("SMTP server:"), gbc, 0, 2, 1, 1);
      gbc.weightx = 100;
      smtpServer = new JTextField(20);
      add(smtpServer, gbc, 1, 2, 1, 1);
 
      gbc.fill = GridBagConstraints.BOTH;
      gbc.weighty = 100;
      message = new JTextArea();
      add(new JScrollPane(message), gbc, 0, 3, 2, 1);

      communication = new JTextArea();
      add(new JScrollPane(communication), gbc, 0, 4, 2, 1);

      gbc.weighty = 0;
      JButton sendButton = new JButton("Send");
      sendButton.addActionListener(new
         ActionListener()
         {
            public void actionPerformed(ActionEvent evt)
            {  
               new 
                  Thread()
                  {
                     public void run()
                     {   
                        sendMail();
                     }
                  }.start();
            }            
         });
      JPanel buttonPanel = new JPanel();
      buttonPanel.add(sendButton);
      add(buttonPanel, gbc, 0, 5, 2, 1);
   }

   /**
      Aade componentes a este marco.
      @parametro c es el componente a aadir
      @parametro gbc la GridBagConstraints
      @parametro x es la columna en la rejilla (frame)
      @parametro y es la fila idem
      @parametro w es la cantidad de columnas de la rejilla
      @parametro h idem, filas
    */
   private void add(Component c, GridBagConstraints gbc,
      int x, int y, int w, int h)
   {  
      gbc.gridx = x;
      gbc.gridy = y;
      gbc.gridwidth = w;
      gbc.gridheight = h;
      getContentPane().add(c, gbc);
   }

   public void sendMail(){// Envia texto introducido en la interfaz 
      try{  
         Socket s = new Socket(smtpServer.getText(), 25);

         out = new PrintWriter(s.getOutputStream());
         in = new BufferedReader(new
            InputStreamReader(s.getInputStream()));

         String hostName
            = InetAddress.getLocalHost().getHostName();

         receive();
         send("HELO " + hostName);
         receive();
         send("MAIL FROM: <" + from.getText() + ">");
         receive();
         send("RCPT TO: <" + to.getText() + ">");
         receive();
         send("DATA");
         receive();
         StringTokenizer tokenizer = new StringTokenizer(
            message.getText(), "\n");
         while (tokenizer.hasMoreTokens())
            send(tokenizer.nextToken());
         send(".");
         receive();
         s.close();
      }
      catch (IOException exception)
      {  
         communication.append("Error: " + exception);
      }
   }

   /**
      Envia una cadena al socket y la repite 
      en el area de texto de la comunicacion.
      @parametro s es la cadena a enviar.
   */
   public void send(String s) throws IOException{  
      communication.append(s);
      communication.append("\n");
      out.print(s);
      out.print("\r\n");
      out.flush();
   }

   /**
      recibe una cadena desde el socket y la muestra en la JTextArea
   */
   public void receive() throws IOException{
      String line = in.readLine();
      if (line != null){
         communication.append(line);
         communication.append("\n");
      }
   }

   private BufferedReader in;
   private PrintWriter out;
   private JTextField from;
   private JTextField to;
   private JTextField smtpServer;
   private JTextArea message;
   private JTextArea communication;

   public static final int WIDTH = 300;
   public static final int HEIGHT = 300;  
}

