//  Gateway para el primer practico de Trabajo en Red

//  Author: Tymoschuk, Jorge

import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

public class PracGate{  //
   	private File       file; 
   	private RandomAccessFile iofile;
   	private String legLei, curLei,  aNomLei;
   	private String algoDecir="";
   	private String direct, archivo, curso, legajo, apeNoms;
	public PracGate(String[] args){
   		direct   = args[0];	// Directorio (tymos)
   		archivo  = args[1];	// Archivo    (regPra01)
   		curso    = args[2];	// Donde cursas ?
   		legajo   = args[3];	// Legajo UTN
   		apeNoms  = args[4];	// Apellido, Nombres 
	}


	boolean errorParm(String[] args) throws IOException{
            String msgeAux = null;
	    if ( args.length != 5){	// Cantidad de parametros difiere   	
		System.out.println("Content-Type: text/html");  // 1st line
		System.out.println();                           // empty line
		System.out.println("<html><H1> Error en parametros </H1>");
                msgeAux = "cantidad recibida " + args.length;
		System.out.println("<P> msgeAux<P></html>");
		System.out.println("<P>difiere de la esperada (5)<P></html>");
	        return true;
            }
            if ( !args[0].equals("tymos")){ 	// Directorio mal informado   	
		System.out.println("Content-Type: text/html");  // 1st line
	   	System.out.println();                           // empty line
	   	System.out.println("<html><H1> Error en parametros </H1>");
	   	System.out.println("<P>args[0] distinto de tymos <P></html>");
		return true;
	    }
	    if ( !args[1].equals("regPra01")){ // Archivo mal informado   	
		System.out.println("Content-Type: text/html");  // 1st line
		System.out.println();                           // empty line
			System.out.println("<html><H1> Error en parametros </H1>");
			System.out.println("<P>args[1] difiere de regPra01 <P></html>");
			return true;
	    }
	    return false;
	}

	boolean openRAF(){
	    // file = new File("./"+direct+"/"+archivo);
            /*  Comentarizamos la linea anterior, ocurre que el servidor
             *  labsys en una maquina Linux, probemos generar el archivo 
             *  en la misma carpeta de la clase         */
            file = new File(archivo+".dat"); 
	    try	{iofile = new RandomAccessFile(file,"rw");
	        return true;
	    }catch (IOException e){
		System.out.println("Content-Type: text/html");  // 1st line
		System.out.println();                           // empty line
		System.out.println("<html><H1> Error en generacion del RAF </H1>");
		System.out.println("<P>openRAF(), IOException<P></html>");
		return false;
	    }	
	}	//	openRAF()
	
	boolean existeLeg(){
	    if(file.length()==0) return false; // primera vez
	    String legLei="00.000"; 
            try{
		while(true){
		    if(legLei.equals(legajo)){	// Encontre igual
			System.out.println("Content-Type: text/html");  // 1st line
			System.out.println();                           // empty line
			System.out.println("<html><H1> Existes !!</H1>");
			System.out.println("<P>"+apeNoms+"<P></html>");
			return true;
		    } 
		    legLei= iofile.readUTF();	//  legajo
		    curLei= iofile.readUTF();	//  curso
		    aNomLei=iofile.readUTF();	//	nombres
		    iofile.readUTF();	//	algo que quiero decir
		}
	    }catch(EOFException e){return false;} // No tengo legajo
		catch(IOException e){
		System.out.println("Content-Type: text/html");  // 1st line
		System.out.println();                           // empty line
		System.out.println("<html><H1> Error de lectura (?) </H1>");
		System.out.println("<P>existeLeg(), IOException<P></html>");
		System.exit(1);
	    }
	    return true;		
	}	//	existeLeg()

	void grabRAF(){
	    try{
	        iofile.writeUTF(legajo);
		iofile.writeUTF(curso);
		iofile.writeUTF(apeNoms);
		// Ahora leemos el flujo enviado por el cliente.
		int c;
		while ((c = System.in.read() ) > -1 )
		    algoDecir+=c;
		    iofile.writeUTF(algoDecir);
		    iofile.close();
		} catch (IOException e){
		    System.out.println("Content-Type: text/html");  // 1st line
		    System.out.println();                           // empty line
		    System.out.println("<html><H1> Error de grabacion </H1>");
		    System.out.println("<P>"+apeNoms+"<P></html>");
		}
	}	//	grabRAF()
        
        void practOk(){
            // confirmacion del exito logrado 
	    System.out.println("Content-Type: text/html");  // 1st line
	    System.out.println();                           // empty line
	    System.out.println("<html><H1> Practico exitoso !!! </H1>");
	    System.out.println("<P>"+apeNoms+"<P></html>");
        }

        public static void main (String[] args) throws IOException{
   	    // PracGate gtw = new PracGate(args);
            /*  Como no sabemos que pasa en labsys, necesitamos probar esto localmente. 
             *  Entonces comentarizamos la linea anterior, construimos un array de
             *  Strings con lo que vendria por el flujo out del cliente ClieGate
             *                                                                  */  
            
            String[] argsAux = {"tymos","regPra01","2k3","12321","Tymos, Jorge"};
            PracGate gtw = new PracGate(argsAux);
	    //  if (gtw.errorParm(args))return;
	    if (gtw.errorParm(argsAux))return;	
            
	    // Consistencia de argumentos correcta, seguimos 
            if (gtw.openRAF())		// Consigo abrir Random Access File
	   	if(!gtw.existeLeg()){ // No tengo legajo, darlo de alta 
	   	    gtw.grabRAF();
                    gtw.practOk();
                }    
	}
}

