import java.io.*;
import java.net.*;

/**
   Este programa hace lo mismo que EchoServer, solo que con tantos clientes
   como se conecten. Usa el mismo puerto 8189.
*/
public class ThreadedEchoServer
{  
   public static void main(String[] args )
   {  
      try
      {  
         int i = 1;
         ServerSocket s = new ServerSocket(8189);

         for (;;)
         {  
            Socket incoming = s.accept( );
            System.out.println("Spawning " + i);
            Thread t = new ThreadedEchoHandler(incoming, i);
            t.start();
            i++;
         }
      }
      catch (Exception e)
      {  
         e.printStackTrace();
      }
   }
}

/**
   La clase siguiente, ThreadedEchoHandler, manipula la entrada del cliente
   mediante una coneccion Socket del servidor. 
*/
class ThreadedEchoHandler extends Thread
{ 
   /**
      Constructs a handler.
      @param i the incoming socket
      @param c the counter for the handlers (used in prompts)
   */
   public ThreadedEchoHandler(Socket i, int c)
   { 
      incoming = i; counter = c; 
   }

   public void run()
   {  
      try
      {  
         BufferedReader in = new BufferedReader
            (new InputStreamReader(incoming.getInputStream()));
         PrintWriter out = new PrintWriter
            (incoming.getOutputStream(), true /* autoFlush */);

         out.println( "Hello! Enter BYE to exit." );

         boolean done = false;
         while (!done)
         {  
            String str = in.readLine();
            if (str == null) done = true;
            else
            {  
               out.println("Echo (" + counter + "): " + str);

               if (str.trim().equals("Adios"))
                  done = true;
            }
         }
         incoming.close();
      }
      catch (Exception e)
      {  
         e.printStackTrace();
      }
   }

   private Socket incoming;
   private int counter;
}

