import java.io.*;
import java.net.*;
import java.util.*;

/**
    Este programa conecta con el URL solicitado por el operador, o con
 *  java.sun.com si no se informa nada. 
 *  Utiliza todos los metodos vistos para exhibir datos de la cabecera,
 *  y las diez primeras lineas de los datos requeridos.
 *  Opcionalmente puede informar usuario y password
*/
public class URLConnectionTest{  
   public static void main(String[] args){
      String urlName  = null; 
      String username = null;
      String password = null;
      try{
         System.out.println("Que URL desea Ud investigar?");
         urlName = In.readLine();
         if (urlName == null)urlName  = "http://java.sun.com";
         System.out.println("Investigamos "+urlName);
         URL url = new URL(urlName);
         URLConnection connection = url.openConnection();

         System.out.println("Si lo desea, puede identificarse ahora");
         username = In.readLine();
         
         System.out.println("Puede ser util disponer de su Password");
         password = In.readLine();
         
         // set username, password if specified on command line

         if (username != null && password != null){  
            String input = username + ":" + password;
            String encoding = URLEncoder.encode(input);
            connection.setRequestProperty("Authorization",
               "Basic " + encoding);
         }

         connection.connect();

         // Mostrar campos de la cabecera 

         int n = 1;
         String key;
         while ((key = connection.getHeaderFieldKey(n)) != null)
         {  
            String value = connection.getHeaderField(n);
            System.out.println(key + ": " + value);
            n++;
         }

         // imprimir campos fundamentales

         System.out.println("----------");
         System.out.println("getContentType: "
            + connection.getContentType());
         System.out.println("getContentLength: "
            + connection.getContentLength());
         System.out.println("getContentEncoding: "
            + connection.getContentEncoding());
         System.out.println("getDate: "
            + connection.getDate());
         System.out.println("getExpiration: "
            + connection.getExpiration());
         System.out.println("getLastModifed: "
            + connection.getLastModified());
         System.out.println("----------");

         BufferedReader in = new BufferedReader(new
            InputStreamReader(connection.getInputStream()));

         // imprimir las 10 primeras lineas del archivo de definicion de la pagina

         String line;
         n = 1;
         while ((line = in.readLine()) != null && n <= 10)
         {  
            System.out.println(line);
            n++;
         }
         if (line != null) System.out.println(". . .");
      }
      catch (IOException exception)
      {  
         exception.printStackTrace();
      }
   }
}

